<template>
  <div class="edit-info-form">
    <div class="avatar" :style="{backgroundImage: `url(${avatar})`}">
      <label for="avatar-input" class="avatar__label">
        <UploadIcon class="upload-icon" />
      </label>
      <input type="file" class="avatar__input" id="avatar-input" accept="image/*" @change="onAvatarChange"/>
    </div>
    <TextField v-model="name" :error="nameError" dark inputType="text" label="نام و نام خانوادگی" id="name" class="field" />
    <TextField v-model="email" :error="emailError" dark inputType="email" label="ایمیل" id="email" class="field" />
    <TextField v-model="phone" :error="phoneError" dark inputType="tel" label="شماره موبایل" id="phone" class="field" />
    <Button type="contained" size="lg" class="submit-button" @click.native="update" :disabled="disabled">بروزرسانی</Button>
  </div>
</template>

<script>
import Button from "@/components/base/Button";
import TextField from "@/components/base/TextField";
import UploadIcon from "@/assets/svgs/upload.svg";

export default {
  components: {
    Button,
    TextField,
    UploadIcon
  },
  props: {
    user: {
      type: Object,
      required: true
    }
  },
  data() {
    return {
      newAvatar: undefined,
      oldName: this.user.name,
      oldPhone: this.user.phone,
      oldEmail: this.user.email,
      name: this.user.name,
      phone: this.user.phone,
      email: this.user.email
    }
  },
  methods: {
    refreshOldInfo() {
      const newUser = this.$store.getters['auth/getUser'];
      this.oldName = newUser.name;
      this.oldPhone = newUser.phone;
      this.oldEmail = newUser.email;
    },
    onEnterKeyPress(e) {
      if (e.key === "Enter" && !this.disabled) {
        this.update();
      }
    },
    onAvatarChange(e) {
      this.newAvatar = e.target.files[0];
      if (this.newAvatar && this.newAvatar.size > 1000000) {
        this.$store.dispatch('notifications/push', {
          message: 'حجم فایل انتخابی بیش از 1 مگابایت است!',
          light: true,
          type: 'warning',
          timeout: 3000
        });
        this.newAvatar = undefined;
      } else if (this.newAvatar) {
        this.$store.dispatch('notifications/push', {
          message: 'فایل انتخاب شد!',
          light: true,
          type: 'success',
          timeout: 1500
        });
      } else {
        this.$store.dispatch('notifications/push', {
          message: 'فایل انتخابی برداشته شد!',
          light: true,
          type: 'success',
          timeout: 1500
        });
      }
    },
    updateAvatar() {
      const token = this.$store.getters['auth/getToken'];
      const data = {
        avatar: this.newAvatar,
        token
      }
      this.$store.dispatch('auth/updateAvatar', data).then(response => {
        if (response.status === 200) {
          this.$store.dispatch('notifications/push', {
            message: 'تصویر پروفایل با موفقیت بروزرسانی شد!',
            light: true,
            type: 'success',
            timeout: 2500
          });
          this.newAvatar = undefined;
        }
      }).catch(error => {
        if (error.status === 400) {
          this.$store.dispatch('notifications/push', {
            message: 'فایل آپلود شده معتبر نمی باشد!',
            type: 'error',
            timeout: 2500
          });
        } else {
          this.$store.dispatch('notifications/push', {
            message: 'خطا در اتصال با سرور لطفا دقایقی دیگر تلاش کنید!',
            type: 'error',
            timeout: 3500
          });
        }
        this.newAvatar = undefined;
      });
    },
    updateInfo() {
      const info = {
        name: this.name || "",
        phone: this.phone || "",
        email: this.email || ""
      };
      const token = this.$store.getters['auth/getToken'];
      const data = {
        info,
        token
      }
      this.$store.dispatch('auth/updateUserInfo', data).then(response => {
        if (response.status === 200) {
          this.$store.dispatch('notifications/push', {
            message: 'مشخصات با موفقیت بروزرسانی شد!',
            light: true,
            type: 'success',
            timeout: 2500
          });
          this.refreshOldInfo();
        } else if (response.status === 400) {
          this.$store.dispatch('notifications/push', {
            message: 'ایمیل وارد شده در سیستم موجود می باشد.',
            type: 'error',
            timeout: 3500
          });
        } else {
          this.$store.dispatch('notifications/push', {
            message: 'خطا در اتصال به سرور! لطفا دقایقی دیگر تلاش کنید.',
            type: 'error',
            timeout: 3500
          });
        }
      }).catch(error => {
        this.$store.dispatch('notifications/push', {
          message: 'خطا در اتصال به سرور! لطفا دقایقی دیگر تلاش کنید.',
          type: 'error',
          timeout: 3500
        });
        console.log(error);
      });
    },
    update() {
      if (this.shouldUpdateAvatar) {
        this.updateAvatar();
      }
      if (this.shouldUpdateInfo) {
        if (this.canUpdateInfo) {
          this.updateInfo();
        } else {
          this.$store.dispatch('notifications/push', {
            message: 'لطفا ورودی های خود را کنترل کنید.',
            light: true,
            type: 'warning',
            timeout: 3500
          });
        }
      } 
    }
  },
  computed: {
    hasNameChanged() {
      return this.oldName !== this.name ? true : false;
    },
    hasPhoneChanged() {
      return this.oldPhone !== this.phone ? true : false;
    },
    hasEmailChanged() {
      return this.oldEmail !== this.email ? true : false;
    },
    shouldUpdateAvatar() {
      return this.newAvatar ? true : false;
    },
    shouldUpdateInfo() {
      return (this.hasNameChanged || this.hasEmailChanged || this.hasPhoneChanged) ? true : false;
    },
    canUpdateInfo() {
      return !this.nameError && !this.emailError && !this.phoneError ? true : false;
    },
    nameError() {
      const regex = /^[آ-ی ء چ]+$/;
      if (!this.name) {
        return "";
      } else if (!regex.test(this.name)) {
        return "فقط از حروف فارسی استفاده کنید!";
      } else {
        return "";
      }
    },
    emailError() {
      const regex = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
      if (!this.email) {
        return "";
      } else if (!regex.test(this.email)) {
        return "ایمیل وارد شده معتبر نمی باشد!";
      } else {
        return "";
      }
    },
    phoneError() {
      const regex = /^(\+98|0)?9\d{9}$/;
      if (!this.phone) {
        return "";
      } else if (!regex.test(this.phone)) {
        return "شماره موبایل وارد شده معتبر نمی باشد!";
      } else {
        return "";
      }
    },
    avatar() {
      return this.user.profilePic ? `${process.env.baseUrl}${this.user.profilePic}` : '/images/profile.png';
    },
    disabled() {
      return (this.shouldUpdateAvatar || this.shouldUpdateInfo) ? false : true;
    }
  },
  mounted() {
    window.addEventListener('keyup', this.onEnterKeyPress);
  },
  beforeDestroy() {
    window.removeEventListener('keyup', this.onEnterKeyPress);
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables"

.avatar
  width $dashboard-info-avatar-size
  height $dashboard-info-avatar-size
  border-radius 50%
  margin $md auto
  background-size cover
  background-position center
  overflow hidden
  &__input
    display none
  &__label
    display flex
    align-items center
    justify-content center
    width 100%
    height 100%
    background-color rgba(black, .5)
    transition all .1s ease-in
    &:hover
      cursor pointer
      background-color rgba(black, .7)

.upload-icon
  fill $white
  width 10rem
  height 10rem

.field
  direction ltr
  &:not(:last-of-type)
    margin-bottom $md

.submit-button
  margin-top $md 
  width 100%
</style>